{% extends "template/app.twig" %}

{% block meta %}
    {% set meta = {'keywords': 'Oportunidades'} %}
    {{ parent() }}
{% endblock %}

{% block link %}
    {{ parent() }}
{% endblock %}

{% block header %}
    {{ parent() }}
{% endblock %}

{% block aside %}
    {{ parent() }}
{% endblock %}

{% block content %}
    {{ parent() }}
    {% include "template/partial/section/brand_list.twig" %}
{% endblock %}

{% block footer %}
    {{ parent() }}
{% endblock %}

{% block script %}
    {{ parent() }}

    <script>
        $(document).ready(function () {

            //Selection
            var gridClient = $("#data-table-brands").bootgrid({
                css: {
                    icon: 'zmdi icon',
                    iconColumns: 'zmdi-view-module',
                    iconDown: 'zmdi-expand-more',
                    iconRefresh: 'zmdi-refresh',
                    iconUp: 'zmdi-expand-less'
                },
                templates: {
                    header: ""
                },
                selection: false,
                multiSelect: false,
                rowSelect: false,
                keepSelection: false,
                statusMappings: {
                    4: "bgm-bluegray",
                    5: "bgm-pink"
                },
                formatters: {
                    "commands": function (column, row) {
                        return "<button type=\"button\" class=\"btn btn-icon command-edit waves-effect waves-circle lo-e\" title=\"Editar marca\" data-brand=\"" + row.brand + "\" data-type=\"" + row.type + "\" data-group-id=\"" + row.group_id + "\" data-id=\"" + row.id + "\"><span class=\"zmdi zmdi-edit\"></span></button> " +
                                "<button type=\"button\" class=\"btn btn-icon command-delete waves-effect waves-circle lo-d\" title=\"Eliminar marca\" data-id=\"" + row.id + "\"><span class=\"zmdi zmdi-delete\"></span></button>";
                    }
                }
            }).on("loaded.rs.jquery.bootgrid", function () {
                gridClient.find(".lo-e").on("click", function (e) {
                    //document.getElementById("create-brand").reset();

                    var id = $(this).data("id");
                    var brand = $(this).data("brand");
                    var type = $(this).data("type");
                    var group_id = $(this).data("group-id");
                    
                    $('#modalDefault').find('.modal-title:first').text('Actualizar Marca');
                    $('#form-new-brand').attr('data-action', 'put');
                    $('#brand_id').val(id);
                    $('#brand_name').val(brand);

                    if(type !== '') {
                        $('#brand_type').selectpicker('val', type);
                    } else {
                        $('#brand_type').selectpicker('deselectAll');
                    }
                    
                    if(group_id > 0 && typeof group_id === 'number') {
                        $('#brand_group').selectpicker('val', group_id);
                    } else {
                        $('#brand_group').selectpicker('deselectAll');
                    }
                    
                    getUsersBrand(id);
                    $('#modalDefault').modal('show');
                });

                gridClient.find(".lo-v").on("click", function (e) {
                    var id = $(this).data("-id");

                    //loadInfoClient(id);
                });

                gridClient.find(".lo-d").on("click", function (e) {
                    var id = $(this).data("id");

                    swal({
                        title: "¿Está seguro de eliminar la marca?",
                        text: "Se perderan todos los datos ingresados!",
                        type: "warning",
                        showCancelButton: true,
                        confirmButtonColor: "#DD6B55",
                        confirmButtonText: "Borrar",
                        cancelButtonText: "Cancelar",
                        closeOnConfirm: true
                    }, function (isConfirm) {
                        if (isConfirm) {
                            $.ajax({
                                type: "DELETE",
                                url: '{{path_for('brand-delete')}}',
                                data: {brand_id: id},
                                dataType: "JSON",
                                success: function (data) {
                                    console.log(data);
                                    if (data.type > 1) {
                                        notify(data.message, 'success');
                                        setTimeout(function () {
                                            window.location.reload();
                                        }, 300);
                                    } else {
                                        notify(data.message, 'warning');
                                    }
                                },
                                error: function (data) {
                                    console.log(data);
                                    notify('Ha ocurrido un error, por favor intente de nuevo!', 'warning');
                                }
                            });
                        }
                    });
                });
            });

            //save
            $(document).on('click', '.save-brand', function () {
                var type = $("#form-new-brand").data('action');
                                
                if (isCheckSave()) {
                    $.ajax({
                        type: type,
                        url: (type === 'put') ? '{{path_for('brand-update')}}' : '{{path_for('brand-create')}}',
                        data: $('#form-new-brand').serializeArray(),
                        dataType: "JSON",
                        success: function (data) {
                            console.log(data);
                            if (data.type > 1) {
                                notify(data.message, 'success');
                                setTimeout(function () {
                                    window.location.reload();
                                }, 300);
                            } else {
                                notify(data.message, 'warning');
                            }
                        },
                        error: function (data) {
                            console.log(data);
                            notify('Ha ocurrido un error, por favor intente de nuevo!', 'warning');
                        }
                    });
                } else {
                    $('#modal-msg').html('\
                        <div class="alert alert-warning alert-dismissible" role="alert">\n\
                            <button type="button" class="close" data-dismiss="alert" aria-label="Close">\n\
                                <span aria-hidden="true">×</span>\n\
                            </button>\n\
                            Completá los campos resaltados\n\
                        </div>'
                    ).show('slow');
                }
            });

            var getUsersBrand = function (id) {
                $.ajax({
                    type: 'GET',
                    url:'{{path_for('brand-users', {'id': id})}}'+id,
                    dataType: "JSON",
                    success: function (data) {
                        var ids = [];
                        $.each(data.users, function(k, v){
                            ids.push(v.user_id);
                        });
                        $('#brand_users').val(ids).trigger('chosen:updated');
                    },
                    error: function (data) {
                        console.log(data);
                        notify('Ha ocurrido un error, al intentar cargar los usuarios!', 'warning');
                    }
                });
            };
            //check form
            var isCheckSave = function () {
                var is = true;
                if ($('#brand_name').val() === '') {
                    $('#brand_name').parents('.fg-line').addClass('has-error');
                    is = false;
                }

                if ($('#brand_type option:selected').val() === '') {
                    $('#brand_type').next('.bootstrap-select').css({'border-bottom': '1px solid red'});
                    is = false;
                } else if ($('#brand_type option:selected').val() === 'otra') {
                    if ($('#brand_type_name').val() === '') {
                        $('#brand_type_name').parent().addClass('has-error');
                        is = false;
                    }
                }

                if ($('#brand_group option:selected').val() === '') {
                    $('#brand_group').next('.bootstrap-select').css({'border-bottom': '1px solid red'});
                    is = false;
                }

                return is;
            };
            
            $('#modalDefault').on('hidden.bs.modal', function () {
                $.each($('#brand_users option'), function(){
                    $(this).removeAttr('selected');
                });
                $('#brand_users').trigger('chosen:updated');

                $('.selectpicker').selectpicker('deselectAll');
                $('#brand_name').parents('.fg-line').removeClass('has-error');
                $('#brand_name').val('');
                $('#brand_group').next('.bootstrap-select').css({'border-bottom': ''});
                $('#brand_type').next('.bootstrap-select').css({'border-bottom': ''});                
            });
            
            $(document).on('click', '#create-brand', function () {
                $('#form-new-brand').attr('data-action', 'post');
                $('#modalDefault').find('.modal-title:first').text('Nueva Marca');
            });

            $(document).on('change', '#brand_group', function () {
                $('#brand_group').next('.bootstrap-select').css({'border-bottom': ''});
                $('#modal-msg').hide('slow');
            });

            $(document).on('change', '#brand_type', function () {
                $('#brand_type').next('.bootstrap-select').css({'border-bottom': ''});
                $('#modal-msg').hide('slow');
                if ($(this).val() === "otra") {
                    $('#brand_type_name').removeAttr('disabled');
                    $('#brand_type_name').parent().parent().show();
                } else {
                    $('#brand_type_name').attr('disabled', 'disabled');
                    $('#brand_type_name').parent().parent().hide();
                }
            });


        });
    </script>

{% endblock %}